"""
Compares times stamps found in the HTTP headers of both 
Internet IPs and I2P sites to the local clock, along 
with retrieval times, generating a CSV file and a 
synopsis in HTML.


Coded by Adrian Crenshaw
Please excuse the sloppiness of the code, I've only recently began to learn Python
http://irongeek.com
"""
import sys
import urllib2
from urllib2 import HTTPError, URLError
import threading
from threading import Thread
import time
from datetime import datetime
import string
import os
import csv
import difflib
import socket
timeout = 25

socket.setdefaulttimeout(timeout)
ThreadsToRun = 20
ScanStartedTime = string.replace(string.replace(str(datetime.now())," ", "-"),":","-")

OutputHTMLFile=open("compare-headers.html", 'ab',1)
OutputCSVFile=open("TimeDiffs" + ScanStartedTime + ".csv", 'w',1)
InputCSV = csv.reader(open('job.txt', 'r'), delimiter=',', quotechar='"')
AllDateStrings=""
class GrabInfo(Thread):
   def __init__ (self,line,proxy):
        Thread.__init__(self)
        self.line = line
        self.proxy = proxy
        self.status = -1
   def run(self):
      global AllDateStrings
      AddMe=""
      CSVLine=""
      try:
         if self.proxy:
            ProxyToUse= urllib2.ProxyHandler({'http': 'http://127.0.0.1:4444/'})
            opener = urllib2.build_opener(ProxyToUse)
         else:
            opener = urllib2.build_opener()
         StartTime =datetime.utcnow()
         url = opener.open("http://" + self.line + "/", None,timeout)
         EndTime =datetime.utcnow()
         InfoString = str(url.info())
         ServerString = url.info().get('server','blank')
         DateString = url.info().get('date', 'Tue, 1 Jan 0001 00:00:00 GMT').replace("+0000","GMT")
         TimeHeaderVal= datetime.strptime(DateString, "%a, %d %b %Y %H:%M:%S %Z")
         ServerTimeDiff = TimeHeaderVal - StartTime
         RunTimeDiff = EndTime - StartTime
         AddMe= str(ServerTimeDiff.total_seconds())+ ','+ str(RunTimeDiff.total_seconds()) +',"' + DateString + '",'+ self.line + ',' + ServerString
         CSVLine=AddMe + '\n'
      except HTTPError, e:
         EndTime =datetime.utcnow()
         ServerString = e.info().get('server','blank')
         DateString = e.info().get('date', 'Tue, 1 Jan 0001 00:00:00 GMT').replace("+0000","GMT")
         TimeHeaderVal= datetime.strptime(DateString, "%a, %d %b %Y %H:%M:%S %Z")
         ServerTimeDiff = TimeHeaderVal - StartTime
         RunTimeDiff = EndTime - StartTime
         AddMe= str(ServerTimeDiff.total_seconds())+ ','+ str(RunTimeDiff.total_seconds()) +',"' + DateString + '",'+ self.line + ',' + ServerString
         CSVLine=AddMe + '\n'
      except:
         print self.line
         print sys.exc_info()
         AddMe = '<font color="#ff0000">' + self.line + ' may have errored out ' + str(StartTime) + '</font>'
      finally:   
         print	AddMe
         OutputCSVFile.write(CSVLine)
         AllDateStrings = AllDateStrings + AddMe + '\n'
     
#TheIP = "178.63.47.16"
#TheHost = "lurker.i2p"

StartingThreadCount=threading.activeCount()
AllStartingThreads= threading.enumerate()
for line in InputCSV:
   TheHost = line[0]
   print "\nOn " + TheHost
   if TheHost[-4:]==".i2p":
    current = GrabInfo(TheHost, True)
   else:
    current = GrabInfo(TheHost, False)
   current.start()
   while threading.activeCount() >= StartingThreadCount + ThreadsToRun:
      time.sleep(1)
i=0
while threading.activeCount() > StartingThreadCount:
   print "starting:", StartingThreadCount
   print "now:", threading.activeCount()
   print AllStartingThreads
   print "-------------------"
   print threading.enumerate()
   if i == 15:
      break
   i = i + 1
   time.sleep(5)

AllDateStringsSorted=""
for entry in(sorted(AllDateStrings.split('\n'))):
   AllDateStringsSorted = AllDateStringsSorted + entry + '\n'
OutputHTMLFile.write('<pre><font color="#0000ff">' + AllDateStringsSorted  + '</font></pre>') 
OutputHTMLFile.close()
OutputCSVFile.close()
print "Done"
