"""
Checks the status of each I2P host listed in an I2P host.txt 
file to see if it's up, and then generates CSV and HTML 
formatted output with the hostname, status, and server 
banner. Input file and proxies will have to be changed based 
on user settings. This script also collects page scrapes that 
can be reviewed.

Coded by Adrian Crenshaw
Please excuse the sloppiness of the code, I've only recently began to learn Python
http://irongeek.com
"""
import sys
import urllib2
import threading
from threading import Thread
import time
from datetime import datetime
import string
import os

ScanStartedTime = string.replace(string.replace(str(datetime.now())," ", "-"),":","-")
ScrapeDir ="I2PPageScrapes" + ScanStartedTime
os.mkdir(ScrapeDir)
#InputFile = open('C:\\Users\\adrian\\AppData\\Roaming\\I2P\\hosts.txt', 'r')
InputFile = open('C:\\Windows\\SysWOW64\\config\\systemprofile\\AppData\\Roaming\\I2P\\hosts.txt', 'r')
OutputFile=open('hostsresults' + ScanStartedTime + '.txt', 'wb',1) 
HTMLFile=open('grabpage' + ScanStartedTime + '.html', 'wb',1) 
IframeFile=open(ScrapeDir + "\\" + "000Iframefun.html", 'wb',1)
#With help from http://forum.i2p2.de/viewtopic.php?p=20843
#Set options in the lines below
ProxyToUse= urllib2.ProxyHandler({'http': 'http://127.0.0.1:4444/'})
ThreadsToRun = 100

opener = urllib2.build_opener(ProxyToUse)
urllib2.install_opener(opener)

def SaveScrape(I2PHostName, data, TheInfo):
   ScrapeFile=open(ScrapeDir + "\\" + I2PHostName +'.html', 'wb',1)
   ScrapeFile.write(data)
   OutToFile = I2PHostName + ":<p><pre>" + TheInfo +"</pre><p><iframe src =\"" + I2PHostName +'.html' + "\" width=\"100%\" height=\"300\"></iframe>"
   IframeFile.write(OutToFile)
   ScrapeFile.close


class GrabURL(Thread):
   def __init__ (self,line):
        Thread.__init__(self)
        self.line = line
        self.status = -1
   def run(self):
      try:
         self.line = self.line.rpartition('=')[0]
         url = urllib2.urlopen("http://" + self.line + "/", None,60)
         InfoString = str(url.info())
         SplitInfo = InfoString.splitlines()
         ServerString = url.info().get('server', 'blank')
         results = '"' + self.line + '"' + "," + '"' + str(url.getcode()) + '"' + "," + '"' + ServerString + '"' + "\n"
         OutputFile.write(results)
         HTMLFile.write('<a href="http://'+ self.line + '">' + self.line + '</a><br>\n')
         SaveScrape(self.line, url.read(), InfoString)
         print results
      except:
         print sys.exc_info()
         None

StartingThreadCount=threading.activeCount()
for line in InputFile:
    current = GrabURL(line)
    current.start()
    while threading.activeCount() >= ThreadsToRun + StartingThreadCount:
      time.sleep(1)
while threading.activeCount() > StartingThreadCount:
   time.sleep(1)
   
ScanEndedTime = string.replace(string.replace(str(datetime.now())," ", "-"),":","-") 
OutputFile.write("Scan started at " + ScanStartedTime + " with " + str(ThreadsToRun) + " threads\n")
HTMLFile.write("Scan started at " + ScanStartedTime + " with " + str(ThreadsToRun) + " threads\n")
OutputFile.write("Scan ended " + ScanEndedTime + "\n")
HTMLFile.write("Scan ended " + ScanEndedTime + "\n")

InputFile.close()
OutputFile.close()

HTMLFile.close()
IframeFile.close
print "Done"
